<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source of the Rust file `/nix/store/kd7w2jm6rvvx6pnfgbmafdxkx875y5cf-vendored-sources/num-0.4.0/src/lib.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>lib.rs - source</title><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceSerif4-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../FiraSans-Regular.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../FiraSans-Medium.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceCodePro-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceSerif4-Bold.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceCodePro-Semibold.ttf.woff2"><link rel="stylesheet" type="text/css" href="../../normalize.css"><link rel="stylesheet" type="text/css" href="../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../ayu.css" disabled><link rel="stylesheet" type="text/css" href="../../dark.css" disabled><link rel="stylesheet" type="text/css" href="../../light.css" id="themeStyle"><script id="default-settings" ></script><script src="../../storage.js"></script><script defer src="../../source-script.js"></script><script defer src="../../source-files.js"></script><script defer src="../../main.js"></script><noscript><link rel="stylesheet" href="../../noscript.css"></noscript><link rel="alternate icon" type="image/png" href="../../favicon-16x16.png"><link rel="alternate icon" type="image/png" href="../../favicon-32x32.png"><link rel="icon" type="image/svg+xml" href="../../favicon.svg"></head><body class="rustdoc source"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="mobile-topbar"><button class="sidebar-menu-toggle">&#9776;</button><a class="sidebar-logo" href="../../num/index.html"><div class="logo-container"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></div>
        </a><h2 class="location"></h2>
    </nav>
    <nav class="sidebar"><a class="sidebar-logo" href="../../num/index.html"><div class="logo-container"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></div>
        </a></nav><main><div class="width-limiter"><div class="sub-container"><a class="sub-logo-container" href="../../num/index.html"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></a><nav class="sub"><form class="search-form"><div class="search-container"><span></span><input class="search-input" name="search" autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"><div id="help-button" title="help" tabindex="-1"><button type="button">?</button></div><div id="settings-menu" tabindex="-1">
                                <a href="../../settings.html" title="settings"><img width="22" height="22" alt="Change settings" src="../../wheel.svg"></a></div>
                        </div></form></nav></div><section id="main-content" class="content"><div class="example-wrap"><pre class="line-numbers"><span id="1">1</span>
<span id="2">2</span>
<span id="3">3</span>
<span id="4">4</span>
<span id="5">5</span>
<span id="6">6</span>
<span id="7">7</span>
<span id="8">8</span>
<span id="9">9</span>
<span id="10">10</span>
<span id="11">11</span>
<span id="12">12</span>
<span id="13">13</span>
<span id="14">14</span>
<span id="15">15</span>
<span id="16">16</span>
<span id="17">17</span>
<span id="18">18</span>
<span id="19">19</span>
<span id="20">20</span>
<span id="21">21</span>
<span id="22">22</span>
<span id="23">23</span>
<span id="24">24</span>
<span id="25">25</span>
<span id="26">26</span>
<span id="27">27</span>
<span id="28">28</span>
<span id="29">29</span>
<span id="30">30</span>
<span id="31">31</span>
<span id="32">32</span>
<span id="33">33</span>
<span id="34">34</span>
<span id="35">35</span>
<span id="36">36</span>
<span id="37">37</span>
<span id="38">38</span>
<span id="39">39</span>
<span id="40">40</span>
<span id="41">41</span>
<span id="42">42</span>
<span id="43">43</span>
<span id="44">44</span>
<span id="45">45</span>
<span id="46">46</span>
<span id="47">47</span>
<span id="48">48</span>
<span id="49">49</span>
<span id="50">50</span>
<span id="51">51</span>
<span id="52">52</span>
<span id="53">53</span>
<span id="54">54</span>
<span id="55">55</span>
<span id="56">56</span>
<span id="57">57</span>
<span id="58">58</span>
<span id="59">59</span>
<span id="60">60</span>
<span id="61">61</span>
<span id="62">62</span>
<span id="63">63</span>
<span id="64">64</span>
<span id="65">65</span>
<span id="66">66</span>
<span id="67">67</span>
<span id="68">68</span>
<span id="69">69</span>
<span id="70">70</span>
<span id="71">71</span>
<span id="72">72</span>
<span id="73">73</span>
<span id="74">74</span>
<span id="75">75</span>
<span id="76">76</span>
<span id="77">77</span>
<span id="78">78</span>
<span id="79">79</span>
<span id="80">80</span>
<span id="81">81</span>
<span id="82">82</span>
<span id="83">83</span>
<span id="84">84</span>
<span id="85">85</span>
<span id="86">86</span>
<span id="87">87</span>
<span id="88">88</span>
<span id="89">89</span>
<span id="90">90</span>
<span id="91">91</span>
<span id="92">92</span>
<span id="93">93</span>
<span id="94">94</span>
<span id="95">95</span>
<span id="96">96</span>
<span id="97">97</span>
<span id="98">98</span>
<span id="99">99</span>
<span id="100">100</span>
<span id="101">101</span>
<span id="102">102</span>
<span id="103">103</span>
<span id="104">104</span>
<span id="105">105</span>
<span id="106">106</span>
<span id="107">107</span>
<span id="108">108</span>
</pre><pre class="rust"><code><span class="comment">// Copyright 2014-2016 The Rust Project Developers. See the COPYRIGHT</span>
<span class="comment">// file at the top-level directory of this distribution and at</span>
<span class="comment">// http://rust-lang.org/COPYRIGHT.</span>
<span class="comment">//</span>
<span class="comment">// Licensed under the Apache License, Version 2.0 &lt;LICENSE-APACHE or</span>
<span class="comment">// http://www.apache.org/licenses/LICENSE-2.0&gt; or the MIT license</span>
<span class="comment">// &lt;LICENSE-MIT or http://opensource.org/licenses/MIT&gt;, at your</span>
<span class="comment">// option. This file may not be copied, modified, or distributed</span>
<span class="comment">// except according to those terms.</span>

<span class="doccomment">//! A collection of numeric types and traits for Rust.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! This includes new types for big integers, rationals, and complex numbers,</span>
<span class="doccomment">//! new traits for generic programming on numeric properties like `Integer`,</span>
<span class="doccomment">//! and generic range iterators.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! ## Example</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! This example uses the BigRational type and [Newton&#39;s method][newt] to</span>
<span class="doccomment">//! approximate a square root to arbitrary precision:</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! ```</span>
<span class="doccomment">//! # #[cfg(any(feature = &quot;alloc&quot;, feature = &quot;std&quot;))]</span>
<span class="doccomment">//! # mod test {</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! use num::FromPrimitive;</span>
<span class="doccomment">//! use num::bigint::BigInt;</span>
<span class="doccomment">//! use num::rational::{Ratio, BigRational};</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! # pub</span>
<span class="doccomment">//! fn approx_sqrt(number: u64, iterations: usize) -&gt; BigRational {</span>
<span class="doccomment">//!     let start: Ratio&lt;BigInt&gt; = Ratio::from_integer(FromPrimitive::from_u64(number).unwrap());</span>
<span class="doccomment">//!     let mut approx = start.clone();</span>
<span class="doccomment">//!</span>
<span class="doccomment">//!     for _ in 0..iterations {</span>
<span class="doccomment">//!         approx = (&amp;approx + (&amp;start / &amp;approx)) /</span>
<span class="doccomment">//!             Ratio::from_integer(FromPrimitive::from_u64(2).unwrap());</span>
<span class="doccomment">//!     }</span>
<span class="doccomment">//!</span>
<span class="doccomment">//!     approx</span>
<span class="doccomment">//! }</span>
<span class="doccomment">//! # }</span>
<span class="doccomment">//! # #[cfg(not(any(feature = &quot;alloc&quot;, feature = &quot;std&quot;)))]</span>
<span class="doccomment">//! # mod test { pub fn approx_sqrt(n: u64, _: usize) -&gt; u64 { n } }</span>
<span class="doccomment">//! # use crate::test::approx_sqrt;</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! fn main() {</span>
<span class="doccomment">//!     println!(&quot;{}&quot;, approx_sqrt(10, 4)); // prints 4057691201/1283082416</span>
<span class="doccomment">//! }</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! ```</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! [newt]: https://en.wikipedia.org/wiki/Methods_of_computing_square_roots#Babylonian_method</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! ## Compatibility</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! The `num` crate is tested for rustc 1.31 and greater.</span>

<span class="attribute">#![<span class="ident">doc</span>(<span class="ident">html_root_url</span> <span class="op">=</span> <span class="string">&quot;https://docs.rs/num/0.4&quot;</span>)]</span>
<span class="attribute">#![<span class="ident">no_std</span>]</span>

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">any</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;alloc&quot;</span>, <span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;std&quot;</span>))]</span>
<span class="kw">pub</span> <span class="kw">use</span> <span class="ident">num_bigint</span>::{<span class="ident">BigInt</span>, <span class="ident">BigUint</span>};

<span class="kw">pub</span> <span class="kw">use</span> <span class="ident">num_complex::Complex</span>;

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">any</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;alloc&quot;</span>, <span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;std&quot;</span>))]</span>
<span class="kw">pub</span> <span class="kw">use</span> <span class="ident">num_rational::BigRational</span>;
<span class="attribute">#[<span class="ident">allow</span>(<span class="ident">deprecated</span>)]</span>
<span class="kw">pub</span> <span class="kw">use</span> <span class="ident">num_rational::Rational</span>;
<span class="kw">pub</span> <span class="kw">use</span> <span class="ident">num_rational</span>::{<span class="ident">Rational32</span>, <span class="ident">Rational64</span>};

<span class="kw">pub</span> <span class="kw">use</span> <span class="ident">num_integer::Integer</span>;

<span class="kw">pub</span> <span class="kw">use</span> <span class="ident">num_iter</span>::{<span class="ident">range</span>, <span class="ident">range_inclusive</span>, <span class="ident">range_step</span>, <span class="ident">range_step_inclusive</span>};

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">any</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;libm&quot;</span>, <span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;std&quot;</span>))]</span>
<span class="kw">pub</span> <span class="kw">use</span> <span class="ident">num_traits::Float</span>;
<span class="kw">pub</span> <span class="kw">use</span> <span class="ident">num_traits</span>::{
    <span class="ident">abs</span>, <span class="ident">abs_sub</span>, <span class="ident">cast</span>, <span class="ident">checked_pow</span>, <span class="ident">clamp</span>, <span class="ident">one</span>, <span class="ident">pow</span>, <span class="ident">signum</span>, <span class="ident">zero</span>, <span class="ident">Bounded</span>, <span class="ident">CheckedAdd</span>,
    <span class="ident">CheckedDiv</span>, <span class="ident">CheckedMul</span>, <span class="ident">CheckedSub</span>, <span class="ident">FromPrimitive</span>, <span class="ident">Num</span>, <span class="ident">NumCast</span>, <span class="ident">One</span>, <span class="ident">PrimInt</span>, <span class="ident">Saturating</span>,
    <span class="ident">Signed</span>, <span class="ident">ToPrimitive</span>, <span class="ident">Unsigned</span>, <span class="ident">Zero</span>,
};

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">any</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;alloc&quot;</span>, <span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;std&quot;</span>))]</span>
<span class="kw">pub</span> <span class="kw">mod</span> <span class="ident">bigint</span> {
    <span class="kw">pub</span> <span class="kw">use</span> <span class="ident">num_bigint</span>::<span class="kw-2">*</span>;
}

<span class="kw">pub</span> <span class="kw">mod</span> <span class="ident">complex</span> {
    <span class="kw">pub</span> <span class="kw">use</span> <span class="ident">num_complex</span>::<span class="kw-2">*</span>;
}

<span class="kw">pub</span> <span class="kw">mod</span> <span class="ident">integer</span> {
    <span class="kw">pub</span> <span class="kw">use</span> <span class="ident">num_integer</span>::<span class="kw-2">*</span>;
}

<span class="kw">pub</span> <span class="kw">mod</span> <span class="ident">iter</span> {
    <span class="kw">pub</span> <span class="kw">use</span> <span class="ident">num_iter</span>::<span class="kw-2">*</span>;
}

<span class="kw">pub</span> <span class="kw">mod</span> <span class="ident">traits</span> {
    <span class="kw">pub</span> <span class="kw">use</span> <span class="ident">num_traits</span>::<span class="kw-2">*</span>;
}

<span class="kw">pub</span> <span class="kw">mod</span> <span class="ident">rational</span> {
    <span class="kw">pub</span> <span class="kw">use</span> <span class="ident">num_rational</span>::<span class="kw-2">*</span>;
}
</code></pre></div>
</section></div></main><div id="rustdoc-vars" data-root-path="../../" data-current-crate="num" data-themes="ayu,dark,light" data-resource-suffix="" data-rustdoc-version="1.64.0-dev" ></div>
</body></html>